extends Area2D

#変数定義
var hp		#-耐久力
var pow		#-パワーアップ段階
var pow_max
var speed=300

var width
var height

var shot=preload("res://player_shot.tscn")
var fire_cntr
var rapid_speed=15

var expload_src=preload("res://players_explode.tscn")
var invinsible_cnt=0

# 生成時処理
func _ready():
	#-暫定
	Gl.screen_size=get_viewport_rect().size
	width=32
	height=32
	fire_cntr=0
	Gl.lost_player=0
	restoreStatus()
	
# 毎フレームごとの処理
func _process(delta):
	#--移動
	var vec=Vector2()
	
	if Input.is_action_pressed("ui_up"):
		vec.y=vec.y-1
	if Input.is_action_pressed("ui_down"):
		vec.y=vec.y+1
	if Input.is_action_pressed("ui_left"):
		vec.x=vec.x-1
	if Input.is_action_pressed("ui_right"):
		vec.x=vec.x+1
	position=position+vec.normalized()*speed*delta
	#-位置補正
	#---横
	if position.x-width/2<0:
		position.x=width/2
	if position.x+width/2>Gl.screen_size.x:
		position.x=Gl.screen_size.x-width/2
	#---縦
	if position.y-height/2<0:
		position.y=height/2
	if position.y+height/2>Gl.screen_size.y:
		position.y=Gl.screen_size.y-height/2
	#-ショット発射
	if Input.is_action_pressed("action_shot"):
		if fire_cntr==0:
			#-ショット発射
			var s=shot.instantiate()
			s.init(position.x,position.y-height/2,270)
			get_parent().add_child(s)
			if pow==1:
				var shot_ang=[-25,25]
				for c in range(0,2):
					var ss=shot.instantiate()
					ss.init(position.x,position.y,270+shot_ang[c])
					get_parent().add_child(ss)
				
		fire_cntr=(fire_cntr+1)%rapid_speed
	#-無敵時の点滅制御
	if invinsible_cnt>0:
		if invinsible_cnt%2==0:
			visible=false
		else:
			visible=true
		invinsible_cnt=invinsible_cnt-1
		
# X座標取得
func X():
	return position.x
	
# Y座標取得
func Y():
	return position.y
	
# HP取得
func HP():
	return hp

#パワーアップ段階取得
func Power():
	return pow

# 状態保存
func saveStatus():
	Gl.save_pos=position
	Gl.save_hp=hp
	Gl.save_pow=pow
	Gl.saved=1
	
# 状態復帰
func restoreStatus():
	if Gl.saved==1:
		position=Gl.save_pos
		hp=Gl.save_hp
		pow=Gl.save_pow
	else:
		hp=1
		pow=0
		position.x=Gl.screen_size.x/2-width/2
		position.y=Gl.screen_size.y-height/2
	var scr:Label=$"../HUD/ShieldsText"
	scr.text="%d" % hp
		
func _on_area_entered(area):
	var co=area.collision_layer
	match co:
		Gl.ENEMY:
			if invinsible_cnt<=0:
				damage()
		Gl.BULLET:
			if invinsible_cnt<=0:
				damage()
		Gl.ITEM:
			powerup()
	area.queue_free()
	
func damage():
	#-敵や敵弾に当たった時の処理をここに書いてね
	
	#--パワーアップ解除
	pow=0
	#--HP減少
	hp=hp-1
	#--HP描画
	var scr:Label=$"../HUD/ShieldsText"
	scr.text="%d" % hp
	#--HPが0になったら……
	if hp<=0:
		Gl.lost_player=1
		#-爆発
		var e=expload_src.instantiate()
		e.init(position.x,position.y)
		get_parent().add_child(e)
		#--消える
		queue_free()
	else:
		#-ダメージ音
		$SEPlayer.play()
		invinsible_cnt=60
func powerup():
	#-アイテムを取ったときの処理をこちらに
	#-効果音素材
	$SEPlayer_Pow.play()
	invinsible_cnt=60
	#-パワーアップ
	pow=1
