extends Node2D

var fighter_src=preload("res://player.tscn")
var stage_cntr
var poper_list=[]
var poper=preload("res://poper.tscn")
var game_scene=preload("res://stage.tscn")
var timer_flag=0
var fade_flag

# Called when the node enters the scene tree for the first time.
func _ready():
	Gl.screen_size=get_viewport_rect()
	reset()
	Gl.fighter=fighter_src.instantiate()
	add_child(Gl.fighter)
	
# Called every frame. 'delta' is the elapsed time since the previous frame.
func _process(delta):
	stage_cntr=stage_cntr+1
	var obj=$HUD/MessageText
	var tw=obj.size.x
	var th=obj.size.y
	if Gl.clear_flag==1:
		$HUD/MessageText.text="STAGE CLEAR!!"
		$HUD/MessageText.position.x=Gl.screen_size.x/2-tw/2
		$HUD/MessageText.position.y=Gl.screen_size.y/2-th/2
		if timer_flag==0:
			timer_flag=1
			$SceneChangeTimer.start()
	
	if Gl.gameover_flag==1:
		$HUD/MessageText.text="GAME OVER"
		$HUD/MessageText.position.x=Gl.screen_size.x/2-tw/2
		$HUD/MessageText.position.y=Gl.screen_size.y/2-th/2
		if timer_flag==0:
			timer_flag=1
			$SceneChangeTimer.start()
			
# ポッパーを作る
func setPoper():
	match Gl.stage:
		1:
			poper_list=[
				[150,0,0,5],[300,0,1,5],[450,0,2,5],[600,0,0,5],[750,2,0,1],
				[900,0,0,5],[1050,1,8,5],[1200,0,1,5],[1350,1,8,5],[1500,3,0,1]
				]
		2:
			poper_list=[
				[150,0,2,5],[300,1,0,5],[450,2,0,1],[600,0,2,5],[750,1,2,5]
				]
			
	for i in poper_list.size():
		var p=poper.instantiate()
		var ptim=poper_list[i][0]
		var ptype=poper_list[i][1]
		var ppos=poper_list[i][2]
		var ppops=poper_list[i][3]
		p.init(ptim,ptype,15,ppos,ppops)
		add_child(p)

func _on_scene_change_timer_timeout():
	if Gl.gameover_flag==1:
		pass
	if Gl.clear_flag==1:
		nextStage()

func gameover():
	pass

func nextStage():
	$HUD/MessageText.text=""
	fade()
	Gl.stage=Gl.stage+1
	if Gl.stage>Gl.stage_max:
		Gl.loop=Gl.loop+1
		Gl.stage=1

func reset():
	$BackScreen.visible=false
	Gl.clear_flag=0
	Gl.gameover_flag=0
	stage_cntr=0
	setPoper()
	$HUD/MessageText.text=""
	$HUD/ScoreText.text="%d" % Gl.score
	$HUD/AreaText.text="%d" % Gl.stage

func fade():
	# BacKScreenを見えるように
	$BackScreen.visible=true
	# アニメを再生
	$AnimationPlayer.play("Fade")

func _on_animation_player_animation_finished(anim_name):
	if anim_name=="Fade":
		$FadeTimer.start()
	if anim_name=="FadeIn":
		$BackScreen.visible=false
		reset()

func _on_fade_timer_timeout():
	$AnimationPlayer.play("FadeIn")
