extends Node2D

var fighter_src=preload("res://player.tscn")
var stage_cntr
var poper_list=[]
var poper=preload("res://poper.tscn")
var game_scene=preload("res://stage.tscn")
var title_scene=preload("res://title.tscn")
var timer_flag=0
var fade_flag
var back_src
var back1
var back2

# Called when the node enters the scene tree for the first time.
func _ready():
	# BGM演奏開始
	$BGMPlayer.play()
	# ステージを追加したり、背景を変えたいときはここを書き換える
	match Gl.stage:
		1:
			back_src=load("res://bg_stage_1.tscn")
		2:
			back_src=load("res://bg_stage_2.tscn")
	back1=back_src.instantiate()
	back1.init(0,1120)
	back2=back_src.instantiate()
	back2.init(-1120,1120)
	add_child(back1)
	add_child(back2)
	Gl.screen_size=get_viewport_rect()
	reset()
	Gl.fighter=fighter_src.instantiate()
	add_child(Gl.fighter)
	
# Called every frame. 'delta' is the elapsed time since the previous frame.
func _process(delta):
	stage_cntr=stage_cntr+1
	var obj=$HUD/MessageText
	var tw=obj.size.x
	var th=obj.size.y
	if Gl.clear_flag==1:
		$HUD/MessageText.text="STAGE CLEAR!!"
		$HUD/MessageText.position.x=Gl.screen_size.x/2-tw/2
		$HUD/MessageText.position.y=Gl.screen_size.y/2-th/2
		if timer_flag==0:
			timer_flag=1
			$SceneChangeTimer.start()
	
	if Gl.gameover_flag==1:
		$HUD/MessageText.text="GAME OVER"
		$HUD/MessageText.position.x=Gl.screen_size.x/2-tw/2
		$HUD/MessageText.position.y=Gl.screen_size.y/2-th/2
		if timer_flag==0:
			timer_flag=1
			$SceneChangeTimer.start()
			
# ポッパーを作る
func setPoper():
	match Gl.stage:
		# ステージを増やしたり、出現順を変えたいときは、#-ここからと#-ここまでの間を
		# 書き換えます。
		# [出現時間,敵の種類,出現位置,出現数]の順
		# 出現位置について
		#      0    1    2
		#   |＝＝＝＝＝＝＝＝＝｜
		#   |               |
		#   |               |
		# 7 |               | 3
		#   |               |
		#   |               |
		#   |＝＝＝＝＝＝＝＝＝｜
		#      6    5    4	
		1:
			# ステージ1
			poper_list=[
				#-ここから
				[150,0,0,5],[300,0,1,5],[450,0,2,5],[600,0,0,5],[750,2,0,1],
				[900,0,0,5],[1050,1,8,5],[1200,0,1,5],[1350,1,8,5],[1500,3,0,1]
				#-ここまで
				]

		2:
			# ステージ2
			poper_list=[
				#-ここから
				[150,0,2,5],[300,1,0,5],[450,2,0,1],[600,0,2,5],[750,1,2,5],
				[900,0,0,5],[1050,0,2,5],[1200,1,0,5],[1350,1,2,5],[1500,3,0,1]
				#-ここまで
				]
			
	for i in poper_list.size():
		var p=poper.instantiate()
		var ptim=poper_list[i][0]
		var ptype=poper_list[i][1]
		var ppos=poper_list[i][2]
		var ppops=poper_list[i][3]
		p.init(ptim,ptype,15,ppos,ppops)
		add_child(p)

func _on_scene_change_timer_timeout():
	if Gl.gameover_flag==1:
		gameover()
	if Gl.clear_flag==1:
		nextStage()

func gameover():
	$BGMPlayer.stop()
	$FadeEffect.scene_move(title_scene)

func nextStage():
	$HUD/MessageText.text=""
	Gl.fighter.saveStatus()
	$BGMPlayer.stop()
	$FadeEffect.scene_move(game_scene)
	Gl.stage=Gl.stage+1
	if Gl.stage>Gl.stage_max:
		Gl.loop=Gl.loop+1
		Gl.stage=1
	reset()
	
func reset():
	Gl.clear_flag=0
	Gl.gameover_flag=0
	stage_cntr=0
	setPoper()
	$HUD/MessageText.text=""
	$HUD/ScoreText.text="%d" % Gl.score
	$HUD/AreaText.text="%d" % Gl.stage
